CRUDpasien/urls.py
from django.urls import path
from .views import *

app_name = 'CRUDpasien'
urlpatterns = [
	path('register_pasien', createpasien, name='createpasien'),
    path('list_pasien', listpasien, name='listpasien'),
    path('detail_pasien/<str:nik>', detailpasien, name='detailpasien'),
    path('delete_pasien/<str:nik>', deletepasien, name='deletepasien'),
    path('update_pasien/<str:nik>', updatepasien, name='updatepasien'),
]

login/urls.py
from django.urls import path
from .views import *

app_name = 'login'
urlpatterns = [
	path('register_admin', register_admin, name='register_admin'),
	path('register_penggunapublik',register_penggunapublik, name='register_penggunapublik'),
    path('register_dokter',register_dokter, name='register_dokter'),
    path('register_adminsatgas',register_adminsatgas, name='register_adminsatgas'),
    path('login_user', login_user, name='login_user'),
    path('logout_user', logout_user, name='logout_user')
]

siruco/urls.py
from django.contrib import admin
from django.urls import path,include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('homepage.urls')),
    path('', include('login.urls')),
    path('', include('dashboard.urls')),
    path('', include('CRUDpasien.urls')),
    path('', include('CRUDpaketmakan.urls')),
    path('', include('CRUhotel.urls')),
    path('', include('rumah_sakit.urls')),
    path('', include('transaksi.urls')),
    path('', include('faskes.urls')),
    path('', include('appointment.urls')),
    path('', include('jadwaldokter.urls')),
    path('', include('ruanganbedRS.urls')),
]

CRUDpasien/models.py
from django.db import models

# Create your models here.

CRUDpasien/forms.py
from django import forms
from django.db import connection

class FormCreatePasien(forms.Form):
    nik=forms.CharField(label='NIK',max_length=50)
    nama= forms.CharField(label='Nama',max_length=20)
    nomor_telepon=forms.CharField(label='Nomor Telepon',max_length=50)
    nomor_hp=forms.CharField(label='Nomor HP', max_length=20)
    jalan_ktp=forms.CharField(label='Alamat(Sesuai KTP) Jalan',max_length=50)
    kel_ktp= forms.CharField(label='Kelurahan', max_length=20)
    kec_ktp=forms.CharField(label='Kecamatan',max_length=50)
    kab_ktp=forms.CharField(label='Kabupaten', max_length=20)
    prov_ktp=forms.CharField(label='Provinsi', max_length=12)
    jalan_dom=forms.CharField(label='Aalamat (Domisili) Jalan',max_length=50)
    kel_dom= forms.CharField(label='Kelurahan', max_length=20)
    kec_dom=forms.CharField(label='Kecamatan',max_length=50)
    kab_dom=forms.CharField(label='Kabupaten', max_length=20)
    prov_dom=forms.CharField(label='Provinsi', max_length=12)

class UpdateFormPasien(forms.Form):
    nik=forms.CharField(label='NIK',max_length=50, disabled=True)
    nama= forms.CharField(label='Nama',max_length=20, disabled=True)
    nomor_telepon=forms.CharField(label='Nomor Telepon',max_length=50)
    nomor_hp=forms.CharField(label='Nomor HP', max_length=20)
    jalan_ktp=forms.CharField(label='Alamat(Sesuai KTP) Jalan',max_length=50)
    kel_ktp= forms.CharField(label='Kelurahan', max_length=20)
    kec_ktp=forms.CharField(label='Kecamatan',max_length=50)
    kab_ktp=forms.CharField(label='Kabupaten', max_length=20)
    prov_ktp=forms.CharField(label='Provinsi', max_length=12)
    jalan_dom=forms.CharField(label='Aalamat (Domisili) Jalan',max_length=50)
    kel_dom= forms.CharField(label='Kelurahan', max_length=20)
    kec_dom=forms.CharField(label='Kecamatan',max_length=50)
    kab_dom=forms.CharField(label='Kabupaten', max_length=20)
    prov_dom=forms.CharField(label='Provinsi', max_length=12)



CRUDpasien/views.py
from django.shortcuts import render, redirect
from django.db import connection
from django.http import HttpResponseRedirect
from django.urls import reverse
from django.contrib import messages
from .forms import *
from django.forms import inlineformset_factory, modelformset_factory
from django.contrib.auth import authenticate, login, logout
from django.db import DatabaseError, transaction
from collections import namedtuple

def namedtuplefetchall(cursor):
    "Return all rows from a cursor as a namedtuple"
    desc = cursor.description
    nt_result = namedtuple('Result', [col[0] for col in desc])
    return [nt_result(*row) for row in cursor.fetchall()]

def listpasien(request):
    username = request.session['username']
    cursor = connection.cursor()
    rolePenggunaPublik = False

    try:
        if (request.session['role'] == 'pengguna_publik'):
            rolePenggunaPublik = True
    except:
        return redirect('/')

    cursor.execute("SET SEARCH_PATH TO SIRUCO")
    cursor.execute("SELECT * FROM PASIEN WHERE idPendaftar = '"+username+"'")
    hasil = namedtuplefetchall(cursor)
    cursor.close()
    response = {
        'list' : hasil,
        'rolePenggunaPublik' : rolePenggunaPublik,
    }
    return render(request, "list_pasien.html", response)

def updatepasien(request, nik, success=True):
    message =""
    nik = str(nik)
    cursor = connection.cursor()
    cursor.execute("SET SEARCH_PATH TO SIRUCO")
    cursor.execute("SELECT * FROM PASIEN WHERE nik = '"+nik+"'")
    hasil = namedtuplefetchall(cursor)
    nik = hasil[0].nik
    pendaftar = hasil[0].idpendaftar
    nama = hasil[0].nama
    nomor_telepon = hasil[0].notelp
    nomor_hp = hasil[0].nohp
    ktp_jalan = hasil[0].ktp_jalan
    ktp_kelurahan = hasil[0].ktp_kelurahan
    ktp_kecamatan = hasil[0].ktp_kecamatan
    ktp_kabkot = hasil[0].ktp_kabkot
    ktp_prov= hasil[0].ktp_prov
    dom_jalan = hasil[0].dom_jalan
    dom_kelurahan = hasil[0].dom_kelurahan
    dom_kecamatan = hasil[0].dom_kecamatan
    dom_kabkot = hasil[0].dom_kabkot
    dom_prov= hasil[0].dom_prov
    form = UpdateFormPasien(initial={
        'nik': nik, 'pendaftar': pendaftar, 'nama': nama, 'nomor_telepon': nomor_telepon, 'nomor_hp': nomor_hp, 'jalan_ktp': ktp_jalan,
        'kel_ktp': ktp_kelurahan, 'kec_ktp': ktp_kecamatan, 'kab_ktp': ktp_kabkot, 'prov_ktp': ktp_prov, 'jalan_dom': dom_jalan, 'kel_dom': dom_kelurahan,
        'kec_dom': dom_kecamatan, 'kab_dom': dom_kabkot, 'prov_dom': dom_prov})
    
    if request.method == 'POST':
        nomor_telepon = request.POST['nomor_telepon']
        nomor_hp= request.POST['nomor_hp']
        jalan_ktp = request.POST['jalan_ktp']
        kel_ktp = request.POST['kel_ktp']
        kec_ktp = request.POST['kec_ktp']
        kab_ktp = request.POST['kab_ktp']
        prov_ktp = request.POST['prov_ktp']
        jalan_dom = request.POST['jalan_dom']
        kel_dom = request.POST['kel_dom']
        kec_dom = request.POST['kec_dom']
        kab_dom = request.POST['kab_dom']
        prov_dom = request.POST['prov_dom']

        try :
            with connection.cursor() as c:
                c.execute("UPDATE PASIEN SET notelp ='"+nomor_telepon+"', nohp ='"+nomor_hp+"', ktp_jalan ='"+jalan_ktp+"', ktp_kecamatan ='"+kec_ktp+"', ktp_kelurahan ='"+kel_ktp+"', ktp_kabkot ='"+kab_ktp+"', ktp_prov ='"+prov_ktp+"', dom_jalan ='"+jalan_dom+"', dom_kecamatan ='"+kec_dom+"', dom_kelurahan ='"+kel_dom+"', dom_kabkot ='"+kab_dom+"', dom_prov ='"+prov_dom+"' WHERE nik ='"+nik+"'")
                cursor.close()
            return HttpResponseRedirect('/list_pasien')
        except Exception as e:
            message = str(e)[80:]
    username = request.session['username']        
    response = {
        'form' : form,
        'message' : message,
        'username' : username
    }
    return render(request, "update_pasien.html", response)

def deletepasien(request, nik):
    nik = str(nik)
    cursor = connection.cursor()
    cursor.execute("SET SEARCH_PATH TO SIRUCO")
    cursor.execute("DELETE FROM PASIEN WHERE nik = '"+nik+"'")
    cursor.close()
    messages.success(request, "Data pasien berhasil terhapus")
    return HttpResponseRedirect(reverse('CRUDpasien:listpasien'))


def detailpasien(request, nik):
    nik = str(nik)
    cursor = connection.cursor()
    cursor.execute("SET SEARCH_PATH TO SIRUCO")
    cursor.execute("SELECT * FROM PASIEN WHERE nik = '"+nik+"'")
    hasil = dictfetchall(cursor)
    cursor.close()
    response = {'detail' : hasil}
    return render(request, "detail_pasien.html", response)

def createpasien(request):
    try:
        if request.method == 'POST':
            registform = FormCreatePasien(request.POST)
            if registform.is_valid():
                nik = registform.cleaned_data['nik']
                nama= registform.cleaned_data['nama']
                nomor_telepon = registform.cleaned_data['nomor_telepon']
                nomor_hp= registform.cleaned_data['nomor_hp']
                jalan_ktp = registform.cleaned_data['jalan_ktp']
                kel_ktp = registform.cleaned_data['kel_ktp']
                kec_ktp = registform.cleaned_data['kec_ktp']
                kab_ktp = registform.cleaned_data['kab_ktp']
                prov_ktp = registform.cleaned_data['prov_ktp']
                jalan_dom = registform.cleaned_data['jalan_dom']
                kel_dom = registform.cleaned_data['kel_dom']
                kec_dom = registform.cleaned_data['kec_dom']
                kab_dom = registform.cleaned_data['kab_dom']
                prov_dom = registform.cleaned_data['prov_dom']

                if check_pasien_is_exist(nama,nik) == False:
                    with connection.cursor() as c:
                        c.execute("INSERT INTO PASIEN VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)",[nik, request.session['username'], nama, jalan_ktp, kel_ktp, kec_ktp, kab_ktp, prov_ktp, jalan_dom, kel_dom, kec_dom, kab_dom, prov_dom, nomor_telepon, nomor_hp])
                    return HttpResponseRedirect(reverse('CRUDpasien:listpasien')) # CHANGE TO DESIRED APP
                else:
                    messages.error(request, 'Data pasien sudah terdaftar')
                    return HttpResponseRedirect('/list_pasien')
                    messages.error(request, 'Data pasien sudah terdaftar')
    except DatabaseError:
        print("2") #cek terminal, masuk ga ini
        messages.error(request, "Data yang diisikan belum lengkap, silahkan lengkapi data terlebih dahulu") # kenapa ga muncul ya
        return HttpResponseRedirect('/register_pasien')
    register_form = FormCreatePasien(request.POST)
    username = request.session['username']
    response = {'register_pasien':register_form,
                'username':username}
    return render(request,'create_pasien.html',response)

def check_pasien_is_exist(nama, nik):
    data = {}
    with connection.cursor() as c:
        c.execute("SET SEARCH_PATH TO SIRUCO")
        c.execute("SELECT * FROM PASIEN where nama = %s AND nik = %s",[nama, nik])
        
        data = dictfetchall(c)
    return len(data) > 0 

def dictfetchall(cursor):
    "Return all rows from a cursor as a dict"
    columns = [col[0] for col in cursor.description]
    return [
        dict(zip(columns, row))
        for row in cursor.fetchall()
    ]

CRUDpasien/templates/create_pasien.html
{% extends "dashboard_pengguna_publik.html" %}
{% load static %}
{% block content %}
</div>
    <form action='' method="POST" class="form-group" style="background-color: aliceblue;margin-top: 100px;">
        {% csrf_token %}
        <div class="form-group"></div>
        <label for="pendaftar">Pendaftar: </label>
    <input id="pendaftar" type="text" name="pendaftar" value="{{username}}" disabled></div>
        {% for field in register_pasien %}
        <div class="form-group">
            {{ field.label_tag }} {{ field }}
        </div>
        {% endfor %}
        <div class="centre-items">
            <input type="submit" class="btn btn-primary" value="SIMPAN">
        </div>
    </form>
</div>
{% endblock %}

CRUDpasien/templates/detail_pasien.html
{% extends "dashboard_pengguna_publik.html" %}
{% load static %}
{% block content %}

<div style="margin-top: 100px;">
    <div class="table-responsive">
      <table class="table table-hover" style="width:60%; margin-left:20%;">
          <thead>
          <tr class="table-light" style="text-align: center;">
              <th scope="col" colspan="2">DETAIL PASIEN</th>
            </tr>
          </thead>
          <tbody>
            {% for pasien in detail %}
            <tr class="table-light" style="text-align:left;">
              <th scope="row">Pendaftar  </th>
              <th scope="row">{{pasien.idpendaftar}}</th>
            </tr>
            {% endfor %}
            {% for pasien in detail %}
            <tr class="table-light" style="text-align: left;">
              <th scope="row">NIK</th>
              <th scope="row">{{pasien.nik}}</th>
            </tr>
            {% endfor %}
            {% for pasien in detail %}
            <tr class="table-light" style="text-align:left;">
              <th scope="row">Nama</th>
              <th scope="row">{{pasien.nama}}</th>
            </tr>
            {% endfor %}
            {% for pasien in detail %}
            <tr class="table-light" style="text-align: left;">
              <th scope="row">Nomor Telepon</th>
              <th scope="row">{{pasien.notelp}}</th>
            </tr>
            {% endfor %}
            {% for pasien in detail %}
            <tr class="table-light" style="text-align:left;">
              <th scope="row">Nomor HP</th>
              <th scope="row">{{pasien.nohp}}</th>
            </tr>
            {% endfor %}
            <tr class="table-light" style="text-align:left;">
                <th scope="row">Alamat sesuai KTP :</th>
              </tr>
            {% for pasien in detail %}
            <tr class="table-light" style="text-align:left;">
              <th scope="row">Jalan</th>
              <th scope="row">{{pasien.ktp_jalan}}</th>
            </tr>
            {% endfor %}
            {% for pasien in detail %}
            <tr class="table-light" style="text-align: left;">
              <th scope="row">Kelurahan</th>
              <th scope="row">{{pasien.ktp_kelurahan}}</th>
            </tr>
            {% endfor %}
            {% for pasien in detail %}
            <tr class="table-light" style="text-align:left;">
              <th scope="row">Kecamatan</th>
              <th scope="row">{{pasien.ktp_kecamatan}}</th>
            </tr>
            {% endfor %}
            {% for pasien in detail %}
            <tr class="table-light" style="text-align:left;">
              <th scope="row">Kabupaten</th>
              <th scope="row">{{pasien.ktp_kabkot}}</th>
            </tr>
            {% endfor %}
            {% for pasien in detail %}
            <tr class="table-light" style="text-align: left;">
              <th scope="row">Provinsi</th>
              <th scope="row">{{pasien.ktp_prov}}</th>
            </tr>
            {% endfor %}
            <tr class="table-light" style="text-align:left;">
                <th scope="row">Alamat sesuai Domisili:</th>
              </tr>
            {% for pasien in detail %}
            <tr class="table-light" style="text-align:left;">
              <th scope="row">Jalan</th>
              <th scope="row">{{pasien.dom_jalan}}</th>
            </tr>
            {% endfor %}
            {% for pasien in detail %}
            <tr class="table-light" style="text-align: left;">
              <th scope="row">Kelurahan</th>
              <th scope="row">{{pasien.dom_kelurahan}}</th>
            </tr>
            {% endfor %}
            {% for pasien in detail %}
            <tr class="table-light" style="text-align:left;">
              <th scope="row">Kecamatan</th>
              <th scope="row">{{pasien.dom_kecamatan}}</th>
            </tr>
            {% endfor %}
            {% for pasien in detail %}
            <tr class="table-light" style="text-align:left;">
              <th scope="row">Kabupaten</th>
              <th scope="row">{{pasien.dom_kabkot}}</th>
            </tr>
            {% endfor %}
            {% for pasien in detail %}
            <tr class="table-light" style="text-align: left;">
              <th scope="row">Provinsi</th>
              <th scope="row">{{pasien.dom_prov}}</th>
            </tr>
            {% endfor %}
          </tbody>
        </table>
      </div>
      <a class="btn btn-info" href="/list_pasien">Kembali</a></th>
  </div>
{% endblock %}

CRUDpasien/templates/list_pasien.html
{% extends "dashboard_pengguna_publik.html" %}
{% load static %}
{% block content %}

<div style="margin-top: 100px;">
    <h1 class="list_title">Daftar Pasien</h1>
    <h2 class="message">{{message}}</h2>
    <div class="table-responsive">
      <table class="table table-hover" style="width:60%; margin-left:20%;">
          <thead>
          <tr class="table-light" style="text-align: center;">
              <th scope="col">NIK</th>
              <th scope="col">Nama Pasien</th>
              <th scope="col" colspan="3">Action</th>
            </tr>
          </thead>
          <tbody>
              {% for pasien in list %}
            <tr class="table-light" style="text-align: center;">
              <th scope="row">{{pasien.nik}}</th>
              <th scope="row">{{pasien.nama}}</th>
              <th scope="row"><a class="btn btn-info" href="{% url 'CRUDpasien:updatepasien' pasien.nik %}">Update</a></th>
              <th scope="row"><a class="btn btn-danger" href="{% url 'CRUDpasien:deletepasien' pasien.nik %}">Delete</a></th>
              <th scope="row"><a class="btn btn-info" href="{% url 'CRUDpasien:detailpasien' pasien.nik %}">Detail</a></th>
            </tr>
            {% endfor %}
          </tbody>
        </table>
      </div>
  </div>
{% endblock %}

CRUDpasien/templates/update_pasien.html
{% extends "dashboard_pengguna_publik.html" %}
{% load static %}
{% block content %}
</div>
    <form action='' method="POST" class="form-group" style="background-color: aliceblue;margin-top: 100px;">
        {% csrf_token %}
        <div class="form-group"></div>
        <label for="pendaftar">Pendaftar </label>
    <input id="pendaftar" type="text" name="pendaftar" value="{{username}}" disabled></div>
        {% for field in form %}
        <div class="form-group">
            {{ field.label_tag }} {{ field }}
        </div>
        {% endfor %}
        <div class="centre-items">
            <input type="submit" class="btn btn-primary" value="UPDATE">
        </div>
    </form>
</div>
{% endblock %}